----------------------------------
-- THE SPECIALISTS RELOADED
-- style by KIRA
----------------------------------

-- SCRIPT PARAMETER SYNTAX
--[[
With the script parameter, you can change the order of specialists per team.

== Changing the specialists for all teams ==
In the script parameter, put:

    t=XXXXXXXX

Where 'X' is a “specialist letter” (see below). Each letter stands for
the role of a hedgehog in the team (in that order).
If you leave out a letter, that hedgehog will be the default.

== Specialist letters ==

  S = Soldier
  E = Engineer
  N = Ninja
  D = Demo
  X = Sniper
  H = Saint
  P = Pyro
  L = Loon
  A = Veteran
  B = Ball boy
  C = Cyborg
  F = Fighter
  G = Guard
  I = Indian
  M = Medic
  O = Clone
  K = Coward
  Q = Quanticity
  R = Researcher
  T = Tapir
  U = Undertaker
  J = Expert
  Y = Marksman
  V = Vampire
  W = Weakener
  Z = Devil
  1 = Pathfinder
  2 = Wizard
 

  
  
== Examples ==
Example 1:

    t=SSSSPPPP

4 soldiers and 4 pyros for all teams.

]]

--------------------
-- TODO
--------------------
-- add proper gameflag checking, maybe (so that we can throw in a .cfg and let the users break everything)


HedgewarsScriptLoad("/Scripts/Locale.lua")
HedgewarsScriptLoad("/Scripts/Tracker.lua")
HedgewarsScriptLoad("/Scripts/Params.lua")

average = 0
-- default team values
local currTeamIdx = 0;
local teamRoles = {
	{'S','E','N','D','X','H','P','L'},
	{'S','E','N','D','X','H','P','L'},
	{'S','E','N','D','X','H','P','L'},
	{'S','E','N','D','X','H','P','L'},
	{'S','E','N','D','X','H','P','L'},
	{'S','E','N','D','X','H','P','L'},
	{'S','E','N','D','X','H','P','L'},
	{'S','E','N','D','X','H','P','L'}
};

local numhhs = 0
local hhs = {}

local ready_time = {}
local current_clan
local new_turn_game_time

local started = false

function onParameters()
	parseParams()
	-- All teams
	if params['t'] ~= nil then
		for i = 1, 8 do
			for j = 1, 8 do
				if string.len(params['t']) >= j  then
					teamRoles[i][j] = string.upper(string.sub(params['t'],j,j));
				end
			end
		end
	end
end

function onNewAmmoStore(groupIndex, hogIndex)

	SetAmmo(amSkip, 9, 0, 0, 0)
	groupIndex = groupIndex + 1
	hogIndex = hogIndex + 1

	if teamRoles[groupIndex][hogIndex] == 'S' then
		SetAmmo(amBazooka, 1, 0, 0, 0)
		SetAmmo(amGrenade, 1, 0, 0, 0)
		SetAmmo(amShotgun, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'E' then
		SetAmmo(amGirder, 2, 0, 0, 0)
		SetAmmo(amBlowTorch, 1, 0, 0, 0)
		SetAmmo(amPickHammer, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'N' then
		SetAmmo(amRope, 9, 0, 0, 0)
		SetAmmo(amParachute, 9, 0, 0, 0)
		SetAmmo(amFirePunch, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'D' then
		SetAmmo(amDynamite, 1, 0, 0, 0)
		SetAmmo(amMine, 1, 0, 0, 0)
		SetAmmo(amDrill, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'X' then
		SetAmmo(amSniperRifle, 1, 0, 0, 0)
		SetAmmo(amDEagle, 1, 0, 0, 0)
		SetAmmo(amPortalGun, 2, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'H' then
		SetAmmo(amSeduction, 9, 0, 0, 0)
		SetAmmo(amResurrector, 1, 0, 0, 0)
		SetAmmo(amInvulnerable, 1, 0, 0, 0)
		SetAmmo(amLowGravity, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'P' then
		SetAmmo(amFlamethrower, 1, 0, 0, 0)
		SetAmmo(amMolotov, 1, 0, 0, 0)
		SetAmmo(amNapalm, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'L' then
		SetAmmo(amBaseballBat, 1, 0, 0, 0)
		SetAmmo(amGasBomb, 1, 0, 0, 0)
		SetAmmo(amKamikaze, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'A' then
		SetAmmo(amMortar, 4, 0, 0, 0)
		SetAmmo(amGirder, 1, 0, 0, 0)
		SetAmmo(amExtraDamage, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'R' then
		SetAmmo(amBee, 2, 0, 0, 0)
		SetAmmo(amPortalGun, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'C' then
		SetAmmo(amDEagle, 4, 0, 0, 0)
		SetAmmo(amLaserSight, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'F' then
		SetAmmo(amLowGravity, 1, 0, 0, 0)
		SetAmmo(amPickHammer, 1, 0, 0, 0)
		SetAmmo(amFirePunch, 3, 0, 0, 0)
		SetAmmo(amExtraDamage, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'G' then
		SetAmmo(amAirMine, 2, 0, 0, 0)
		SetAmmo(amGirder, 2, 0, 0, 0)
		SetAmmo(amInvulnerable, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'I' then
		SetAmmo(amSMine, 1, 0, 0, 0)
		SetAmmo(amMolotov, 2, 0, 0, 0)
		SetAmmo(amHammer, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'M' then
		SetAmmo(amRope, 1, 0, 0, 0)
		SetAmmo(amSwitch, 1, 0, 0, 0)
		SetAmmo(amResurrector, 1, 0, 0, 0)
		SetAmmo(amInvulnerable, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'O' then
		SetAmmo(amSineGun, 1, 0, 0, 0)
		SetAmmo(amShotgun, 2, 0, 0, 0)
		SetAmmo(amSniperRifle, 1, 0, 0, 0)
		SetAmmo(amParachute, 9, 0, 0, 0)
		SetAmmo(amExtraDamage, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'K' then
		SetAmmo(amSeduction, 1, 0, 0, 0)
		SetAmmo(amIceGun, 1, 0, 0, 0)
		SetAmmo(amKamikaze, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'Q' then
		SetAmmo(amSineGun, 9, 0, 0, 0)
		SetAmmo(amInvulnerable, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'B' then
		SetAmmo(amBallgun, 3, 0, 0, 0)
		SetAmmo(amLowGravity, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'T' then
		SetAmmo(amRope, 1, 0, 0, 0)
		SetAmmo(amSMine, 1, 0, 0, 0)
		SetAmmo(amInvulnerable, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'U' then
		SetAmmo(amHammer, 3, 0, 0, 0)
		SetAmmo(amResurrector, 1, 0, 0, 0)
		SetAmmo(amJetpack, 1, 0, 0, 0)
		SetAmmo(amPickHammer, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'J' then
		SetAmmo(amLaserSight, 1, 0, 0, 0)
		SetAmmo(amDrill, 1, 0, 0, 0)
		SetAmmo(amPortalGun, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'Y' then
		SetAmmo(amJetpack, 2, 0, 0, 0)
		SetAmmo(amSniperRifle, 4, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'V' then
		SetAmmo(amTeleport, 9, 0, 0, 0)
		SetAmmo(amResurrector, 1, 0, 0, 0)
		SetAmmo(amSnowball, 5, 0, 0, 0)
		SetAmmo(amVampiric, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'W' then
		SetAmmo(amJetpack, 2, 0, 0, 0)
		SetAmmo(amBirdy, 2, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == 'Z' then
		SetAmmo(amMolotov, 4, 0, 0, 0)
		SetAmmo(amInvulnerable, 1, 0, 0, 0)
		SetAmmo(amExtraTime, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == '0' then
		SetAmmo(amExtraTime, 1, 0, 0, 0)
		SetAmmo(amLaserSight, 1, 0, 0, 0)
		SetAmmo(amExtraDamage, 1, 0, 0, 0)
		SetAmmo(amLowGravity, 1, 0, 0, 0)
		SetAmmo(amSwitch, 1, 0, 0, 0)
		SetAmmo(amTeleport, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == '1' then
		SetAmmo(amCake, 1, 0, 0, 0)
		SetAmmo(amBlowTorch, 1, 0, 0, 0)
		SetAmmo(amPickHammer, 1, 0, 0, 0)
	elseif teamRoles[groupIndex][hogIndex] == '2' then
		SetAmmo(amSineGun, 6, 0, 0, 0)
		SetAmmo(amResurrector, 1, 0, 0, 0)
	end

end

function CreateTeam()

	currTeam = ""
	lastTeam = ""
	z = 0

	for i = 0, (numhhs-1) do

		currTeam = GetHogTeamName(hhs[i])

		if currTeam == lastTeam then
			z = z + 1
		else
			z = 1
			currTeamIdx = currTeamIdx + 1;
		end


		if teamRoles[currTeamIdx][z] == 'S' then

			SetHogName(hhs[i],loc("Soldier"))
			SetHogHat(hhs[i], "sf_vega")
			SetHealth(hhs[i], 200)
		elseif teamRoles[currTeamIdx][z] == 'E' then

			SetHogHat(hhs[i], "Glasses")
			SetHogName(hhs[i],loc("Engineer"))
			SetHealth(hhs[i], 100)
		elseif teamRoles[currTeamIdx][z] == 'N' then

			SetHogName(hhs[i],loc("Ninja"))
			SetHogHat(hhs[i], "NinjaFull")
			SetHealth(hhs[i], 80)

		elseif teamRoles[currTeamIdx][z] == 'D' then

			SetHogName(hhs[i],loc("Demo"))
			SetHogHat(hhs[i], "Skull")
			SetHealth(hhs[i], 200)

		elseif teamRoles[currTeamIdx][z] == 'X' then

			SetHogName(hhs[i],loc("Sniper"))
			SetHogHat(hhs[i], "Sniper")
			SetHealth(hhs[i], 120)
		elseif teamRoles[currTeamIdx][z] == 'H' then

			SetHogName(hhs[i],loc("Saint"))
			SetHogHat(hhs[i], "angel")
			SetHealth(hhs[i], 300)
		elseif teamRoles[currTeamIdx][z] == 'P' then

			SetHogName(hhs[i],loc("Pyro"))
			SetHogHat(hhs[i], "Gasmask")
			SetHealth(hhs[i], 150)

		elseif teamRoles[currTeamIdx][z] == 'L' then

			SetHogName(hhs[i],loc("Loon"))
			SetHogHat(hhs[i], "clown")
			SetHealth(hhs[i], 100)

		elseif teamRoles[currTeamIdx][z] == 'A' then

			SetHogHat(hhs[i], "Rambo")
			SetHogName(hhs[i],loc("Veteran"))
			SetHealth(hhs[i], 200)
		elseif teamRoles[currTeamIdx][z] == 'R' then

			SetHogName(hhs[i],loc("Researcher"))
			SetHogHat(hhs[i], "Einstein")
			SetHealth(hhs[i], 150)

		elseif teamRoles[currTeamIdx][z] == 'C' then

			SetHogName(hhs[i],loc("Cyborg"))
			SetHogHat(hhs[i], "cyborg1")
			SetHealth(hhs[i], 200)

		elseif teamRoles[currTeamIdx][z] == 'F' then

			SetHogName(hhs[i],loc("Fighter"))
			SetHogHat(hhs[i], "StrawHatFacial")
			SetHealth(hhs[i], 200)

		elseif teamRoles[currTeamIdx][z] == 'G' then

			SetHogName(hhs[i],loc("Guard"))
			SetHogHat(hhs[i], "policecap")
			SetHealth(hhs[i], 150)

		elseif teamRoles[currTeamIdx][z] == 'I' then

			SetHogName(hhs[i],loc("Indian"))
			SetHogHat(hhs[i], "IndianChief")
			SetHealth(hhs[i], 200)

		elseif teamRoles[currTeamIdx][z] == 'M' then

			SetHogName(hhs[i],loc("Medic"))
			SetHogHat(hhs[i], "fr_apple")
			SetHealth(hhs[i], 250)

		elseif teamRoles[currTeamIdx][z] == 'O' then

			SetHogHat(hhs[i], "scif_swStormtrooper")
			SetHogName(hhs[i],loc("Clone"))
			SetHealth(hhs[i], 200)
		elseif teamRoles[currTeamIdx][z] == 'K' then

			SetHogName(hhs[i],loc("Coward"))
			SetHogHat(hhs[i], "barrelhider")
			SetHealth(hhs[i], 200)
		elseif teamRoles[currTeamIdx][z] == 'Q' then

			SetHogName(hhs[i],loc("Quanticity"))
			SetHogHat(hhs[i], "poke_voltorb")
			SetHealth(hhs[i], 50)

		elseif teamRoles[currTeamIdx][z] == 'B' then

			SetHogName(hhs[i],loc("Ball boy"))
			SetHogHat(hhs[i], "bb_bob")
			SetHealth(hhs[i], 200)

		elseif teamRoles[currTeamIdx][z] == 'T' then

			SetHogName(hhs[i],loc("Tapir"))
			SetHogHat(hhs[i], "zoo_elephant")
			SetHealth(hhs[i], 80)

		elseif teamRoles[currTeamIdx][z] == 'U' then

			SetHogName(hhs[i],loc("Undertaker"))
			SetHogHat(hhs[i], "sm_wario")
			SetHealth(hhs[i], 60)
		elseif teamRoles[currTeamIdx][z] == 'J' then

			SetHogName(hhs[i],loc("Expert"))
			SetHogHat(hhs[i], "pirate_eyepatch")
			SetHealth(hhs[i], 120)

		elseif teamRoles[currTeamIdx][z] == 'Y' then

			SetHogHat(hhs[i], "RobinHood")
			SetHogName(hhs[i],loc("Marksman"))
			SetHealth(hhs[i], 200)

		elseif teamRoles[currTeamIdx][z] == 'V' then

			SetHogName(hhs[i],loc("Vampire"))
			SetHogHat(hhs[i], "vampirichog")
			SetHealth(hhs[i], 1)

		elseif teamRoles[currTeamIdx][z] == 'W' then

			SetHogName(hhs[i],loc("Weakener"))
			SetHogHat(hhs[i], "sf_blanka")
			SetHealth(hhs[i], 100)
		elseif teamRoles[currTeamIdx][z] == 'Z' then

			SetHogName(hhs[i],loc("Devil"))
			SetHogHat(hhs[i], "Evil")
			SetHealth(hhs[i], 180)

		elseif teamRoles[currTeamIdx][z] == '0' then

			SetHogName(hhs[i],loc("KIRA"))
			SetHogHat(hhs[i], "zoo_octopus")
			SetHealth(hhs[i], 1)

		elseif teamRoles[currTeamIdx][z] == '1' then

			SetHogName(hhs[i],loc("Pathfinder"))
			SetHogHat(hhs[i], "scif_Geordi")
			SetHealth(hhs[i], 150)

		elseif teamRoles[currTeamIdx][z] == '2' then

			SetHogName(hhs[i],loc("Wizard"))
			SetHogHat(hhs[i], "WizardHat")
			SetHealth(hhs[i], 300)

		end

		lastTeam = GetHogTeamName(hhs[i])

	end

end

function onGameInit()
	-- Force-disable harmful game flags
	DisableGameFlags(gfSharedAmmo, gfKing)
	-- Force-enable game-critical game flags
	EnableGameFlags(gfPerHogAmmo, gfResetWeps)
	-- NOTE: For your game scheme, these game flags are recommended: gfResetWeps, gfPlaceHog, gfSwitchHog, gfInfAttack

	-- No weapon crates
	HealthCaseProb = 100

	-- Instructions
	Goals = loc("The Specialists Reloaded: Each hedgehog starts with its own weapon set.,| In the script parameter put: t=XXXXXXXX where 'X' is a “specialist letter”, Specialists letters:| A = Veteran B = Ball boy C = Cyborg D = Demo E = Engineer| F = Fighter G = Guard H = Saint I = Indian J = Expert| K = Coward L = Loon M = Medic N = Ninja| O = Clone P = Pyro Q = Quanticity  R = Researcher  S = Soldier| T = Tapir U = Undertaker V = Vampire  W = Weakener X = Sniper| Y = Marksman Z = Devil 1 = Pathfinder 2 = Wizard")
end

function onGameStart()
	CreateTeam()
	trackTeams()
		for clan = 0, ClansCount - 1 do
        ready_time[clan] = GetAwayTime * 1000
    end

end


function onNewTurn()

	started = true
	AddCaption(string.format(loc("Prepare yourself, %s!"), GetHogName(CurrentHedgehog)))

		 current_clan = GetHogClan(CurrentHedgehog)
    SetReadyTimeLeft(ready_time[current_clan])
    new_turn_game_time = GameTime

end

function onGameTick20()
    if new_turn_game_time and ReadyTimeLeft == 0 then
        ready_time[current_clan] = ready_time[current_clan] + new_turn_game_time - GameTime
        new_turn_game_time = nil
    end
end

function onGearAdd(gear)

	if GetGearType(gear) == gtHedgehog then
		hhs[numhhs] = gear
		numhhs = numhhs + 1
	elseif (GetGearType(gear) == gtMine) and (started == true) then
		SetTimer(gear,5000)
	elseif (GetGearType(gear) == gtSineGunShot) then
		SetGearValues (gear, nil, nil, nil, 1, nil, nil, nil, nil, nil, nil, nil, nil, 0)
	elseif GetHogHat(CurrentHedgehog) == 'cyborg1' then
			if (GetGearType(gear) == gtDEagleShot) then
			SetHealth(gear, 200)
			end
	elseif GetHogHat(CurrentHedgehog) == 'RobinHood' then
			if (GetGearType(gear) == gtSniperRifleShot) then
			SetHealth(gear, 200)
			end
	elseif GetHogHat(CurrentHedgehog) == 'bb_bob' then
			if (GetGearType(gear) == gtBallGun) then
			SetTimer(gear,1)
			end
			if (GetGearType(gear) == gtBall) then
			SetTimer(gear,750)
			SetGearValues (gear, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, 65)
			end
	elseif GetHogHat(CurrentHedgehog) == 'pirate_eyepatch' then
			if (GetGearType(gear) == gtDrill) then
			SetGearValues (gear, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, 30)
			end
	end
	if (GetGearType(gear) == gtHedgehog) or (GetGearType(gear) == gtResurrector) then
		trackGear(gear)
	end

end

function onGearDelete(gear)
	if (GetGearType(gear) == gtHedgehog) or (GetGearType(gear) == gtResurrector) then
		trackDeletion(gear)
	end
end

